︠742275ca-04e5-4e7c-b4ef-7f05b3053ec0︠
# Mini project: Comparing convergence of the simple iteration method and the Newton's method
#Consider the function f(x)=exp(-x)*(x^2-5*x-2)+1.
# Plot the function to convince yourself that the function has two roots. For each of the roots use the "find_root" function to obtain high accuracy value of the root1 and root2.
#For each of the roots Do the following
#(a) (challenging!) Convert the root-finding problem for f to a fixed point problem g(x)=x with appropriate function g.
#(b) Choose an initial approximation of the root that guarantees convergence of the simple iteration and make a list L with n=7 iterates using simple iteration.
#(c) Use the same initial guess for solving the root-finding problem by Newton's method. Make a list N with n=7 iterates using Newton's iterations.
#(d) Make a table with 7 rows for x[n]-values, n=0..6, and 3 columns with the table header n, L[n],and N[n]. Compare convergence of these two methods.
︡1eadac08-9ca7-4dde-af48-ef961b0fa360︡
︠1dbf603b-a52b-440a-aa4f-c35c18fb7e0ds︠
reset
︡b14fc62b-ecff-4fc9-b281-4e02251cabaa︡{"stdout":"<function reset at 0x7effb05d00c8>"}︡{"stdout":"\n"}︡{"done":true}
︠8093f9d6-20a9-489d-88b2-3f0b25e70b27︠

︡233447c1-efad-4a99-82c6-a92256bcb236︡
︠86355c0e-0602-48b5-9464-efb4ba0c479as︠
f(x)=exp(-x)*(x^2-5*x-2)+1
plot(f(x),x,-1,3, figsize=[3,4])
︡a8621d43-984a-4194-9cc0-4d97553c0662︡{"file":{"filename":"/home/user/.sage/temp/project-fdca50c1-5926-45c5-a180-d8d3e7f819b2/437/tmp_WfktuO.svg","show":true,"text":null,"uuid":"1a347a62-a259-46d7-9f10-9fb4159e977e"},"once":false}︡{"done":true}
︠4a4d22cb-68d7-423c-8776-201a8f6a64c0s︠
root1=find_root(f,-1,0);root1
︡83c1e8c4-f177-4a3c-a2a4-85a38d0f36d2︡{"stdout":"-0.23054999321338798"}︡{"stdout":"\n"}︡{"done":true}
︠1be9301c-84f6-42e7-960e-608667dcd58fs︠
root2=find_root(f,1,3);root2
︡7b4d1837-1f13-4d86-a068-4e534c1d2768︡{"stdout":"2.0895848494844653\n"}︡{"done":true}
︠94307de5-07dc-43ca-ba01-bb055db3ccaes︠
#Version 1
# (a) Solve the equation f(x)=0 for x. Hint: there are three options here. Do not solve for x in the exponential function. The other two options will work.
g1(x)=(x^2+exp(x)-2)/5
︡c2739872-2df4-49d7-b14d-b47e03cd307a︡{"done":true}
︠0d70e8bf-3792-4c7d-a23a-6cbc8831ec58s︠
line_plot1=plot(x,-1,0)
g1plot=plot(g1,-1,3,figsize=[4,3])
g1prime_plot=plot(((2/5)*x+exp(x)/5),-1,3,color='red')
(g1plot+g1prime_plot+line_plot1).show()
︡ba1fab17-3bc2-48c2-b648-2ab90672e903︡{"file":{"filename":"/home/user/.sage/temp/project-c2e46271-e550-4aa2-9e76-891fcc7c29eb/83595/tmp_e19SFj.svg","show":true,"text":null,"uuid":"967e6580-4ced-4cdc-a27c-38b3a6b8e61b"},"once":false}︡{"done":true}
︠52e0da3e-c342-48fa-a928-8f47cbbed09ds︠
#(b) g1 works well for root1; gprime near the root1 is ?. Let x0=-0.9
def simple_iteration(g,a,n):
    L=[a]
    temp=a
    for j in range(1,n+1):
        temp=g(L[j-1]).n()# Encode the iteration formula here
        L.append(temp)
    return L

simple_it_list1=simple_iteration(g1,-0.9,7);simple_it_list1
︡d53f4cae-8893-4891-b29a-1d616161a52d︡{"stdout":"[-0.900000000000000, -0.156686068051880, -0.224095411245832, -0.230108474460778, -0.230520533881549, -0.230548030998561, -0.230549862530082, -0.230549984509961]\n"}︡{"done":true}
︠e00e5690-d093-4b91-a166-541a011df254s︠
# (c) Plot of f shows that the same initial guess will work for approximating root1 by Newton's method ( since ?>0)

def my_newton(f,a,n):
    L=[a]
    fprime=diff(f,x)
    for j in range(n):
        xold=N(L[j])
        #Your code for Newton's formula is incorrect
        #xnew=f(L[j-1])-(f(L[j-1])/fprime(L[j-1])) # Encode Newton's formula here
        #Here is a correct code:
        xnew=xold-(f(x=xold)/fprime(x=xold))
        L.append(xnew)
    return L
︡2057ee8f-4ddc-406e-add6-6c5d3c62ca4e︡{"done":true}
︠9501e13a-c978-470f-a9fb-2c94b108d473s︠
newtons_list1=my_newton(f,-0.9,7);newtons_list1
︡28feb97e-b44d-4b1f-973e-94040c9fe122︡{"stdout":"[-0.900000000000000, -0.532386779451968, -0.313764802062772, -0.238603685771938, -0.230633323982670, -0.230550002235008, -0.230549993213389, -0.230549993213389]\n"}︡{"done":true}
︠5e5f46af-18ed-482f-9d20-0e7ff78c44c1s︠
#(d) Recall that the exact root1 is -0.23054999321338895
nlist=[j for j in range(7)]
table(columns=[nlist,simple_it_list1,newtons_list1],header_row=['n',"Simple iterations", "Newton's iterations"], frame=True)#learn the synatax of this valuable command

︡13831666-4bba-4308-9c93-4457b3fdd8e7︡{"stdout":"+---+--------------------+---------------------+\n| n | Simple iterations  | Newton's iterations |\n+===+====================+=====================+\n| 0 | -0.900000000000000 | -0.900000000000000  |\n+---+--------------------+---------------------+\n| 1 | -0.156686068051880 | -0.532386779451968  |\n+---+--------------------+---------------------+\n| 2 | -0.224095411245832 | -0.313764802062772  |\n+---+--------------------+---------------------+\n| 3 | -0.230108474460778 | -0.238603685771938  |\n+---+--------------------+---------------------+\n| 4 | -0.230520533881549 | -0.230633323982670  |\n+---+--------------------+---------------------+\n| 5 | -0.230548030998561 | -0.230550002235008  |\n+---+--------------------+---------------------+\n| 6 | -0.230549862530082 | -0.230549993213389  |\n+---+--------------------+---------------------+\n"}︡{"done":true}
︠ce282e27-298d-43ab-9205-96372ad2f7a9︠
# Comment:the simple iterations its approching -.23and the newtons its approching -.23
︡902d9b7d-4de7-46c3-870c-64a1c2dd2157︡
︠09d14d90-6c23-427a-b53b-199d24c3afec︠
###################################
︡ffb91f94-e86c-4cfb-a7dc-79a3182e6f7b︡
︠6295f4f9-2b2d-4169-aee7-95a2eb7c17e6s︠
g2(x)=(5*x+2-exp(x))^1/2
︡dffdd68d-de98-43c6-ad7d-3659a2f8533b︡{"done":true}
︠8c8bd63e-b007-4c4e-afe6-9847de2b0e1b︠

︡199003ec-aef6-4870-9fc7-a9318c96b065︡
︠338e7b8a-bad8-441b-b4d2-a4d242669e2f︠

︡c75c0a0e-e591-4da1-a401-2e74234e0adb︡
︠4fd25221-940a-46dc-8ecf-02e00220bf86s︠
diff(g2(x))
︡ea8596f1-332b-4354-93c8-c7c3caa171dc︡{"stdout":"-1/2*e^x + 5/2\n"}︡{"done":true}
︠831df516-138a-4e74-b5cc-ab556b065984s︠
# Version 2: Root 2
# (a)
line_plot2=plot(x,1,2.5)
g2(x)=(5*x+2-exp(x))^0.5
g2plot=plot(g2(x),1,2.5)
g2prime_plot=plot(-1/2*exp(x) + 5/2,1,2.5,color='red')# g2prime is incorrect
g2prime=diff(g2,x);g2prime
(g2plot+g2prime_plot+line_plot2).show(figsize=[4,3])
︡6f79f517-c68f-4923-85b8-5d6c52dbf4d4︡{"stdout":"x |--> -0.500000000000000*(e^x - 5)/sqrt(5*x - e^x + 2)\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-fdca50c1-5926-45c5-a180-d8d3e7f819b2/437/tmp_ppyeWT.svg","show":true,"text":null,"uuid":"e061e8de-a502-4d3e-9313-15d9c42049d6"},"once":false}︡{"done":true}
︠903264a6-ea0c-4555-b767-9ec80ce9ee11s︠
# (b) g2 works well for root2; there is an interval containing root2 where gprime is ?. Let x0=1.2
simple_it_list2=simple_iteration(g2,1.2,7);simple_it_list2
︡5fd1ec9a-6ee7-45b0-898c-aacc6d513e9d︡{"stdout":"[1.20000000000000, 2.16330374133256, 2.02896192145109, 2.13040446092206, 2.05760815511591, 2.11206412847833, 2.07244694614844, 2.10190300751602]\n"}︡{"done":true}
︠bc3a714f-ba20-4cf4-a2ec-430e86bf2d57︠

︡bad74a4b-203e-49ad-89a2-e5b08099bd1e︡{"done":true}
︠bc1a63b3-f9f9-4a2e-8ab8-ef2a7d13c62fs︠
#c)
f(x)=(-1/2*exp(x) + 5/2)
newtons_list2=my_newton(f,1.2,7);newtons_list2
︡3608c92c-c650-4b07-8fbc-dea8c0eae503︡{"stdout":"[1.20000000000000, 1.70597105956101, 1.61395085974027, 1.60944808047909, 1.60943791248579, 1.60943791243410, 1.60943791243410, 1.60943791243410]\n"}︡{"done":true}
︠535887d5-c9de-4c0a-a491-e28d21a391b5s︠
#(d) Recal exact root2: 2.0895848494844653
table(columns=[nlist,simple_it_list2,newtons_list2],header_row=['n',"Simple iterations", "Newton's iterations"], frame=True)

###############
#Grading: There are 20 red question marks; correct replacement for each is 0.5 point. There are two brown question marks (theoretical); each replacement 2 points. Total: 12 points.
︡f74ce94e-1956-4d5f-b974-8d836866262c︡{"stdout":"+---+-------------------+---------------------+\n| n | Simple iterations | Newton's iterations |\n+===+===================+=====================+\n| 0 | 1.20000000000000  | 1.20000000000000    |\n+---+-------------------+---------------------+\n| 1 | 2.16330374133256  | 1.70597105956101    |\n+---+-------------------+---------------------+\n| 2 | 2.02896192145109  | 1.61395085974027    |\n+---+-------------------+---------------------+\n| 3 | 2.13040446092206  | 1.60944808047909    |\n+---+-------------------+---------------------+\n| 4 | 2.05760815511591  | 1.60943791248579    |\n+---+-------------------+---------------------+\n| 5 | 2.11206412847833  | 1.60943791243410    |\n+---+-------------------+---------------------+\n| 6 | 2.07244694614844  | 1.60943791243410    |\n+---+-------------------+---------------------+\n"}︡{"done":true}
︠4522a6b3-2e87-49ad-879a-cdb569aa7fe5︠









